/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v44</h1>       <p>Introduced in Cloudera Manager 7.4.4</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 7.4.4
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger.model;

import java.util.Objects;
import com.cloudera.api.swagger.model.Storage;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * A HBase snapshot operation error.
 */
@ApiModel(description = "A HBase snapshot operation error.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2021-07-30T19:53:47.322Z")
public class ApiHBaseSnapshotError {
  @SerializedName("tableName")
  private String tableName = null;

  @SerializedName("snapshotName")
  private String snapshotName = null;

  @SerializedName("storage")
  private Storage storage = null;

  @SerializedName("storageLocation")
  private String storageLocation = null;

  @SerializedName("error")
  private String error = null;

  public ApiHBaseSnapshotError tableName(String tableName) {
    this.tableName = tableName;
    return this;
  }

   /**
   * Name of the table.
   * @return tableName
  **/
  @ApiModelProperty(value = "Name of the table.")
  public String getTableName() {
    return tableName;
  }

  public void setTableName(String tableName) {
    this.tableName = tableName;
  }

  public ApiHBaseSnapshotError snapshotName(String snapshotName) {
    this.snapshotName = snapshotName;
    return this;
  }

   /**
   * Name of the snapshot.
   * @return snapshotName
  **/
  @ApiModelProperty(value = "Name of the snapshot.")
  public String getSnapshotName() {
    return snapshotName;
  }

  public void setSnapshotName(String snapshotName) {
    this.snapshotName = snapshotName;
  }

  public ApiHBaseSnapshotError storage(Storage storage) {
    this.storage = storage;
    return this;
  }

   /**
   * Whether the snapshot is local or remote.
   * @return storage
  **/
  @ApiModelProperty(value = "Whether the snapshot is local or remote.")
  public Storage getStorage() {
    return storage;
  }

  public void setStorage(Storage storage) {
    this.storage = storage;
  }

  public ApiHBaseSnapshotError storageLocation(String storageLocation) {
    this.storageLocation = storageLocation;
    return this;
  }

   /**
   * The remote location where a snapshot is stored. /_*  Optional - location comes from HBase service config if this is not defined
   * @return storageLocation
  **/
  @ApiModelProperty(value = "The remote location where a snapshot is stored. /_*  Optional - location comes from HBase service config if this is not defined")
  public String getStorageLocation() {
    return storageLocation;
  }

  public void setStorageLocation(String storageLocation) {
    this.storageLocation = storageLocation;
  }

  public ApiHBaseSnapshotError error(String error) {
    this.error = error;
    return this;
  }

   /**
   * Description of the error.
   * @return error
  **/
  @ApiModelProperty(value = "Description of the error.")
  public String getError() {
    return error;
  }

  public void setError(String error) {
    this.error = error;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiHBaseSnapshotError apiHBaseSnapshotError = (ApiHBaseSnapshotError) o;
    return Objects.equals(this.tableName, apiHBaseSnapshotError.tableName) &&
        Objects.equals(this.snapshotName, apiHBaseSnapshotError.snapshotName) &&
        Objects.equals(this.storage, apiHBaseSnapshotError.storage) &&
        Objects.equals(this.storageLocation, apiHBaseSnapshotError.storageLocation) &&
        Objects.equals(this.error, apiHBaseSnapshotError.error);
  }

  @Override
  public int hashCode() {
    return Objects.hash(tableName, snapshotName, storage, storageLocation, error);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiHBaseSnapshotError {\n");
    
    sb.append("    tableName: ").append(toIndentedString(tableName)).append("\n");
    sb.append("    snapshotName: ").append(toIndentedString(snapshotName)).append("\n");
    sb.append("    storage: ").append(toIndentedString(storage)).append("\n");
    sb.append("    storageLocation: ").append(toIndentedString(storageLocation)).append("\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

