# cm_client.ControlPlanesResourceApi

All URIs are relative to *https://localhost/api/v44*

Method | HTTP request | Description
------------- | ------------- | -------------
[**generate_copy_docker**](ControlPlanesResourceApi.md#generate_copy_docker) | **POST** /controlPlanes/commands/generateCopyDocker | Launches the Generate Copy Docker Script Command.
[**generate_external_vault_setup**](ControlPlanesResourceApi.md#generate_external_vault_setup) | **POST** /controlPlanes/commands/generateExternalVaultSetup | Launches the Generate Vault Setup Command command.
[**get_control_planes**](ControlPlanesResourceApi.md#get_control_planes) | **GET** /controlPlanes | Current Control Planes.
[**get_experience_cluster**](ControlPlanesResourceApi.md#get_experience_cluster) | **GET** /controlPlanes/{controlPlaneUuid}/getExperienceCluster | The Experience cluster this control plane is associated with, if any.
[**get_log_content**](ControlPlanesResourceApi.md#get_log_content) | **POST** /controlPlanes/fetchResources/{commandId}/logContent | Fetches the log content for the specific command.
[**get_manifest_json**](ControlPlanesResourceApi.md#get_manifest_json) | **POST** /controlPlanes/fetchResources/manifest.json | Fetches the manifest.
[**install_control_plane**](ControlPlanesResourceApi.md#install_control_plane) | **POST** /controlPlanes/commands/installControlPlane | Launches the install control plane command.
[**install_embedded_control_plane**](ControlPlanesResourceApi.md#install_embedded_control_plane) | **POST** /controlPlanes/commands/installEmbeddedControlPlane | Brings up a control plane on embedded kubernetes.
[**read_control_plane_by_uuid**](ControlPlanesResourceApi.md#read_control_plane_by_uuid) | **GET** /controlPlanes/{controlPlaneUuid} | The control plane with the given id.
[**uninstall_control_plane**](ControlPlanesResourceApi.md#uninstall_control_plane) | **POST** /controlPlanes/{controlPlaneUuid}/commands/uninstallControlPlane | Launches Uninstall Command on the control plane with the given uuid.
[**update_values_yaml**](ControlPlanesResourceApi.md#update_values_yaml) | **POST** /controlPlanes/{controlPlaneUuid}/commands/updateControlPlaneValuesYaml | Launches update the values.
[**upgrade_control_plane**](ControlPlanesResourceApi.md#upgrade_control_plane) | **POST** /controlPlanes/{controlPlaneUuid}/commands/upgradeControlPlane | Launches the Upgrade Command on the control plane with the given uuid.


<a name="generate_copy_docker" id="generate_copy_docker"></a>
# **generate_copy_docker**
> ApiCommand generate_copy_docker(body=body)

Launches the Generate Copy Docker Script Command.

Launches the Generate Copy Docker Script Command

### Example
```python
from __future__ import print_function
import time
import cm_client
from cm_client.rest import ApiException
from pprint import pprint

# Configure HTTP basic authorization: basic
configuration = cm_client.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = cm_client.ControlPlanesResourceApi(cm_client.ApiClient(configuration))
body = cm_client.ApiGenerateCopyDockerArgs() # ApiGenerateCopyDockerArgs | Arguments for the Command (optional)

try:
    # Launches the Generate Copy Docker Script Command.
    api_response = api_instance.generate_copy_docker(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ControlPlanesResourceApi->generate_copy_docker: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ApiGenerateCopyDockerArgs**](ApiGenerateCopyDockerArgs.md)| Arguments for the Command | [optional] 

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="generate_external_vault_setup" id="generate_external_vault_setup"></a>
# **generate_external_vault_setup**
> ApiCommand generate_external_vault_setup(body=body)

Launches the Generate Vault Setup Command command.

Launches the Generate Vault Setup Command command

### Example
```python
from __future__ import print_function
import time
import cm_client
from cm_client.rest import ApiException
from pprint import pprint

# Configure HTTP basic authorization: basic
configuration = cm_client.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = cm_client.ControlPlanesResourceApi(cm_client.ApiClient(configuration))
body = cm_client.ApiGenerateExternalVaultSetupArgs() # ApiGenerateExternalVaultSetupArgs | Arguments for the Command (optional)

try:
    # Launches the Generate Vault Setup Command command.
    api_response = api_instance.generate_external_vault_setup(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ControlPlanesResourceApi->generate_external_vault_setup: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ApiGenerateExternalVaultSetupArgs**](ApiGenerateExternalVaultSetupArgs.md)| Arguments for the Command | [optional] 

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="get_control_planes" id="get_control_planes"></a>
# **get_control_planes**
> ApiControlPlaneList get_control_planes()

Current Control Planes.

Current Control Planes

### Example
```python
from __future__ import print_function
import time
import cm_client
from cm_client.rest import ApiException
from pprint import pprint

# Configure HTTP basic authorization: basic
configuration = cm_client.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = cm_client.ControlPlanesResourceApi(cm_client.ApiClient(configuration))

try:
    # Current Control Planes.
    api_response = api_instance.get_control_planes()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ControlPlanesResourceApi->get_control_planes: %s\n" % e)
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**ApiControlPlaneList**](ApiControlPlaneList.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="get_experience_cluster" id="get_experience_cluster"></a>
# **get_experience_cluster**
> ApiCluster get_experience_cluster(control_plane_uuid)

The Experience cluster this control plane is associated with, if any.

The Experience cluster this control plane is associated with, if any

### Example
```python
from __future__ import print_function
import time
import cm_client
from cm_client.rest import ApiException
from pprint import pprint

# Configure HTTP basic authorization: basic
configuration = cm_client.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = cm_client.ControlPlanesResourceApi(cm_client.ApiClient(configuration))
control_plane_uuid = 'control_plane_uuid_example' # str | The universally unique id of the control plane

try:
    # The Experience cluster this control plane is associated with, if any.
    api_response = api_instance.get_experience_cluster(control_plane_uuid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ControlPlanesResourceApi->get_experience_cluster: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **control_plane_uuid** | **str**| The universally unique id of the control plane | 

### Return type

[**ApiCluster**](ApiCluster.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="get_log_content" id="get_log_content"></a>
# **get_log_content**
> file get_log_content(command_id)

Fetches the log content for the specific command.

Fetches the log content for the specific command.

### Example
```python
from __future__ import print_function
import time
import cm_client
from cm_client.rest import ApiException
from pprint import pprint

# Configure HTTP basic authorization: basic
configuration = cm_client.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = cm_client.ControlPlanesResourceApi(cm_client.ApiClient(configuration))
command_id = 56 # int | the command id

try:
    # Fetches the log content for the specific command.
    api_response = api_instance.get_log_content(command_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ControlPlanesResourceApi->get_log_content: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **command_id** | **int**| the command id | 

### Return type

[**file**](file.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: text/plain

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="get_manifest_json" id="get_manifest_json"></a>
# **get_manifest_json**
> file get_manifest_json(body=body)

Fetches the manifest.

Fetches the manifest.json under the specified remote repo.

### Example
```python
from __future__ import print_function
import time
import cm_client
from cm_client.rest import ApiException
from pprint import pprint

# Configure HTTP basic authorization: basic
configuration = cm_client.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = cm_client.ControlPlanesResourceApi(cm_client.ApiClient(configuration))
body = cm_client.ApiRemoteRepoUrl() # ApiRemoteRepoUrl | the remote repo url. (optional)

try:
    # Fetches the manifest.
    api_response = api_instance.get_manifest_json(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ControlPlanesResourceApi->get_manifest_json: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ApiRemoteRepoUrl**](ApiRemoteRepoUrl.md)| the remote repo url. | [optional] 

### Return type

[**file**](file.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="install_control_plane" id="install_control_plane"></a>
# **install_control_plane**
> ApiCommand install_control_plane(body=body)

Launches the install control plane command.

Launches the install control plane command.

### Example
```python
from __future__ import print_function
import time
import cm_client
from cm_client.rest import ApiException
from pprint import pprint

# Configure HTTP basic authorization: basic
configuration = cm_client.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = cm_client.ControlPlanesResourceApi(cm_client.ApiClient(configuration))
body = cm_client.ApiInstallControlPlaneArgs() # ApiInstallControlPlaneArgs | Arguments for the Command (optional)

try:
    # Launches the install control plane command.
    api_response = api_instance.install_control_plane(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ControlPlanesResourceApi->install_control_plane: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ApiInstallControlPlaneArgs**](ApiInstallControlPlaneArgs.md)| Arguments for the Command | [optional] 

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="install_embedded_control_plane" id="install_embedded_control_plane"></a>
# **install_embedded_control_plane**
> ApiCommand install_embedded_control_plane(body=body)

Brings up a control plane on embedded kubernetes.

Brings up a control plane on embedded kubernetes. At its core, this command launches the FirstRun command on the Experience cluster

### Example
```python
from __future__ import print_function
import time
import cm_client
from cm_client.rest import ApiException
from pprint import pprint

# Configure HTTP basic authorization: basic
configuration = cm_client.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = cm_client.ControlPlanesResourceApi(cm_client.ApiClient(configuration))
body = cm_client.ApiInstallEmbeddedControlPlaneArgs() # ApiInstallEmbeddedControlPlaneArgs | The arguments for Ek8s control plane installation (optional)

try:
    # Brings up a control plane on embedded kubernetes.
    api_response = api_instance.install_embedded_control_plane(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ControlPlanesResourceApi->install_embedded_control_plane: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ApiInstallEmbeddedControlPlaneArgs**](ApiInstallEmbeddedControlPlaneArgs.md)| The arguments for Ek8s control plane installation | [optional] 

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="read_control_plane_by_uuid" id="read_control_plane_by_uuid"></a>
# **read_control_plane_by_uuid**
> ApiControlPlane read_control_plane_by_uuid(control_plane_uuid)

The control plane with the given id.

The control plane with the given id

### Example
```python
from __future__ import print_function
import time
import cm_client
from cm_client.rest import ApiException
from pprint import pprint

# Configure HTTP basic authorization: basic
configuration = cm_client.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = cm_client.ControlPlanesResourceApi(cm_client.ApiClient(configuration))
control_plane_uuid = 'control_plane_uuid_example' # str | The universally unique id of the control plane

try:
    # The control plane with the given id.
    api_response = api_instance.read_control_plane_by_uuid(control_plane_uuid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ControlPlanesResourceApi->read_control_plane_by_uuid: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **control_plane_uuid** | **str**| The universally unique id of the control plane | 

### Return type

[**ApiControlPlane**](ApiControlPlane.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="uninstall_control_plane" id="uninstall_control_plane"></a>
# **uninstall_control_plane**
> ApiCommand uninstall_control_plane(control_plane_uuid, body=body)

Launches Uninstall Command on the control plane with the given uuid.

Launches Uninstall Command on the control plane with the given uuid

### Example
```python
from __future__ import print_function
import time
import cm_client
from cm_client.rest import ApiException
from pprint import pprint

# Configure HTTP basic authorization: basic
configuration = cm_client.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = cm_client.ControlPlanesResourceApi(cm_client.ApiClient(configuration))
control_plane_uuid = 'control_plane_uuid_example' # str | The universally unique id of the control plane
body = cm_client.ApiUninstallControlPlaneArgs() # ApiUninstallControlPlaneArgs | Arguments for the Command (optional)

try:
    # Launches Uninstall Command on the control plane with the given uuid.
    api_response = api_instance.uninstall_control_plane(control_plane_uuid, body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ControlPlanesResourceApi->uninstall_control_plane: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **control_plane_uuid** | **str**| The universally unique id of the control plane | 
 **body** | [**ApiUninstallControlPlaneArgs**](ApiUninstallControlPlaneArgs.md)| Arguments for the Command | [optional] 

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="update_values_yaml" id="update_values_yaml"></a>
# **update_values_yaml**
> ApiCommand update_values_yaml(control_plane_uuid, body=body)

Launches update the values.

Launches update the values.yaml from the control plane with the given uuid This updates the content of values.yaml.merged in the CM database.

### Example
```python
from __future__ import print_function
import time
import cm_client
from cm_client.rest import ApiException
from pprint import pprint

# Configure HTTP basic authorization: basic
configuration = cm_client.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = cm_client.ControlPlanesResourceApi(cm_client.ApiClient(configuration))
control_plane_uuid = 'control_plane_uuid_example' # str | The universally unique id of the control plane
body = cm_client.ApiUpdateControlPlaneValuesYamlArgs() # ApiUpdateControlPlaneValuesYamlArgs | Arguments for the Command (optional)

try:
    # Launches update the values.
    api_response = api_instance.update_values_yaml(control_plane_uuid, body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ControlPlanesResourceApi->update_values_yaml: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **control_plane_uuid** | **str**| The universally unique id of the control plane | 
 **body** | [**ApiUpdateControlPlaneValuesYamlArgs**](ApiUpdateControlPlaneValuesYamlArgs.md)| Arguments for the Command | [optional] 

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="upgrade_control_plane" id="upgrade_control_plane"></a>
# **upgrade_control_plane**
> ApiCommand upgrade_control_plane(control_plane_uuid, body=body)

Launches the Upgrade Command on the control plane with the given uuid.

Launches the Upgrade Command on the control plane with the given uuid

### Example
```python
from __future__ import print_function
import time
import cm_client
from cm_client.rest import ApiException
from pprint import pprint

# Configure HTTP basic authorization: basic
configuration = cm_client.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = cm_client.ControlPlanesResourceApi(cm_client.ApiClient(configuration))
control_plane_uuid = 'control_plane_uuid_example' # str | The universally unique id of the control plane
body = cm_client.ApiUpgradeControlPlaneArgs() # ApiUpgradeControlPlaneArgs | Arguments for the Command (optional)

try:
    # Launches the Upgrade Command on the control plane with the given uuid.
    api_response = api_instance.upgrade_control_plane(control_plane_uuid, body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ControlPlanesResourceApi->upgrade_control_plane: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **control_plane_uuid** | **str**| The universally unique id of the control plane | 
 **body** | [**ApiUpgradeControlPlaneArgs**](ApiUpgradeControlPlaneArgs.md)| Arguments for the Command | [optional] 

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

